class Entry {
  String title; 
  int[] count = new int[TIME_POINTS];
  color c;
  PVector position = new PVector(0, 0, 0);
  int prevy = 0;
  float size = 0.0;
  float pos_rate = 0.0;
  float size_rate = 0.0;
  float avgCount = 0.0;
  
  Entry(String title, int agent_index) {
    this.title = title;
    position.z = agent_index*10 + 50; // spaced every 10 pixels
    for (int i = 0; i < TIME_POINTS; i++) {
      count[i] = 0; // init with 0
    }
    
    c = color(map(position.z, 0, width, 0, 255), 255, 255); // start with 0 brightness
  }
  
  void storeTimePoints(int i, int ct) { 
    if ( i >= 0 && i < TIME_POINTS) {
      count[i] = ct;
    }
  }
  
  void calcAvg() {
    for (int i = 0; i < TIME_POINTS; i++) {
      avgCount += count[i];
    }
    avgCount /= TIME_POINTS;
    
  }
  
  boolean updatePosition(int time_index) {
    size = map(count[time_index], 0, 500, 1, 20);

    position.x = time_index * 10;
    // which way are we incrementing y
    if ((position.y + system_rate) <= count[time_index]) { position.y += system_rate; } 
    if ((position.y - system_rate) >= count[time_index]) { position.y -= system_rate; }
    
    if ((int)position.y >= count[time_index] - 5 && 
        (int)position.y <= count[time_index] + 5) { 
      //println("position reached");
      return true;  
    } else { return false; }
  }

  void drawAgent() {
    pushMatrix();
    fill(c);
    noStroke();
    lights();
    translate(position.x, position.y, position.z);
    //ellipse(0, 0, size, size);
    sphere(size);
    popMatrix();
  }
  
  void drawAgentHistory(int time_index) {
    
    for (int i = 0; i < time_index; i++) {
      pushMatrix();
      fill(c, 50); 
      translate(position.x, count[i], position.z);
      sphere(size);
      popMatrix();
    }
    
  }
}
